function [gMatrix] = getGfunction(Image, centerx, centery)

%Gets a matrix of  Intensity-Based Gaussian Filter 

centerValue = Image(centerx, centery);

gMatrix = double(zeros(3,3));

gMatrix(1,1) = Image((centerx - 1), (centery - 1)) - centerValue;
gMatrix(1,2) = Image((centerx - 1), (centery)) - centerValue;
gMatrix(1,3) = Image((centerx - 1), (centery + 1)) - centerValue;
gMatrix(2,1) = Image((centerx), (centery - 1))- centerValue;
gMatrix(2,2) = Image(centerx, centery) - centerValue;
gMatrix(2,3) = Image((centerx), (centery + 1)) - centerValue;
gMatrix(3,1) = Image((centerx + 1), (centery - 1)) - centerValue;
gMatrix(3,2) = Image((centerx + 1), (centery))- centerValue;
gMatrix(3,3) = Image((centerx + 1), (centery + 1)) - centerValue;

for x=1:3
    for y=1:3
        
        gMatrix(x,y) = exp(-(((gMatrix(x,y)).^2)./(2.*((0.5).^2))));
        
    end
end



